%%---------------------------------------------------------------------------%%
%%                        APPcode
%%---------------------------------------------------------------------------%%
<<

	Purpose:  Code generator for APP Generator.

>>

%----------- Procedure... APPCode ---------------------------------
%
%	Purpose: Generate code for APP Generator
%
%------------------------------------------------------------------
procedure APPCode ( in vlMetaName) \
            local (vlMenuName, \
				   vlFormName, \
				   vlWinName, \
				   vlPgmName, \
				   vlPgmEVName, \
				   vlStateName, \
                   vlDirName)

on break
  goto ExitProc
endon

  set save
  set reset
  set information off
  set output trim on

  let vObjMgmt.MetaObjName = vlMetaName \
      vObjMgmt.MetaType = "APP" \
      vObjMgmt.ObjHeading = "Application" \
      vObjMgmt.NameUpdate = $False

  compute all ObjMgmtDriverEnt where \
     MetaName = vObjMgmt.MetaObjName and \
     MetaType = "APP" \
     eval ((let vlDirName = {ObjMgmtDriverEnt.AttrValue \
                               where AttrName = "ObjDir", \
                             vlDirName}), \
           (let vlMenuName = {ObjMgmtDriverEnt.AttrValue \
                               where AttrName = "MenuName", \
                             vlMenuName}), \
           (let vlFormName = {ObjMgmtDriverEnt.AttrValue \
                               where AttrName = "FormName", \
                             vlFormName}), \
           (let vlPgmName = {ObjMgmtDriverEnt.AttrValue \
                               where AttrName = "PgmName", \
                             vlPgmName}), \
           (let vlPgmEVName = {ObjMgmtDriverEnt.AttrValue \
                               where AttrName = "PgmEVName", \
                             vlPgmEVName}), \
           (let vlStateName = {ObjMgmtDriverEnt.AttrValue \
                               where AttrName = "StateName", \
                             vlStateName}), \
           (let vlWinName = {ObjMgmtDriverEnt.AttrValue \
                               where AttrName = "WindowName", \
                             vlWinName}))

% Assign global macros to represent the program name, etc.
  let <PgmEVNameND> = $trim(vlPgmEVName) \
      <PgmEVName> = $concat($trim(vlDirName), \
                          ".", \
                          $trim(vlPgmEVName)) \
      <PgmNameND> = $trim(vlPgmName) \
      <PgmName> = $concat ($trim(vlDirName), \
                              ".", \
                              $trim(vlPgmName)) \
      <WindowName> = $concat ($trim(vlDirName), \
                              ".", \
                              $trim(vlWinName)) \
      <WindowNameND> = $trim(vlWinName) \
      <MenuName> = $concat ($trim(vlDirName), \
                              ".", \
                              $trim(vlMenuName)) \
      <MenuNameND> = $trim(vlMenuName) \
      <FormName> = $concat ($trim(vlDirName), \
                              ".", \
                              $trim(vlFormName)) \
      <StateName> = $trim(vlStateName)  \
      <MetaName> = $trim(vObjMgmt.MetaObjName) \
      <DirName> = $trim(vlDirName)


% Generate code from program template.

  pAppDesignTrace ("SET", "", "Generating application programs")

  generate APPTemplate

ExitProc:

  set restore

endprocedure

%=========================================================================

