%%--------------------------------------------------------------------------
%%
%%   Application Code Generation:
%%
%% INTRODUCTION
%%
%%   Template for application programs.  Invoked from APPCode (code.app).
%%
%% OBJECTS
%%
%%   Generated by APPObjects (file objects.app)
%%
%%--------------------------------------------------------------------------
LOCALPROCEDURE PLCODETEMPLATE () \
   LOCAL (VLSTATUS, VLPGMNAME)
SET SAVE
LET <GenerationDate> = $CONCAT($MASK($date, 'DD'), \
                               $MASK($MONTHNAME($date), '-???-'), \
                               $MASK($date, 'YY')) \
    <GenerationTime> = $MASK($time, '??:??:??.??') \
    <DCRevision> = $TRIM($DCRevision) 
    
%% Get user modifications
PUSERCODE (VLSTATUS, "INIT", "")
PUSERCODE (VLSTATUS, "LOAD", "#<PgmEVName>")
PUSERCODE (VLSTATUS, "ANALYZE", "")

SET OUTPUT #<PgmEVName>
<<
%%  Meta object name                #<MetaName>
%%  Generation date                 #<GenerationDate>
%%  Generation time                 #<GenerationTime>
%%  Development Centre Revision     #<DCRevision>
>>
SET SAVE
SET HEADINGS OFF
SET COLUMNSPACING 2
LIST ALL OBJMGMTDRIVERENT WHERE METATYPE = "APP" AND METANAME = "#<MetaName>" \
   SORTED BY ATTRDESC \
   FORMAT "%%" $TOCHAR(ATTRDESC,30) ATTRVALUE
SET RESTORE
<<
%%---------------------------------------------------------------------------
%%
%% Generated by the Application Designer from template APPTemplate.
%% APPCode sets up some global macros before generating from APPTemplate.
%% The required objects are built using APPObjects.
%%
%% The attributes of this meta object are listed above.
%%
%% You may wish to customize the generated code. Places where you are likely
%% to do this are marked by comments that begin with '%% TO DO:'
%%
%%---------------------------------------------------------------------------

%%------------------------ #<PgmEVNameND> ----------------------------------

%% Purpose:   Main event loop that calls standard main app window that
%%            can, in turn, invoke apps.
%%
%% YOU MUST ACCESS $DEPLOYSERVICES IN ORDER TO RUN THIS PROGRAM!

%% Comments:
%%   Application Model:
%%     Application Designer generates code and objects that are designed to be
%%     used with the Application Framework introduced in Version 5.1. The basic
%%     structure of applications is shown below:
%%
%%                        +------------+
%%                        | Event Loop |
%%                        +------------+
%%                              |
%%                        +------------+
%%                        | Main Window|
%%                        +------------+
%%                              |
%%                        +------------+
%%                        | Other      |--+
%%                        | Windows    |  |
%%                        +------------+  |
%%                           +------------+
%%      * Every application has a "main window" (the first one that appears
%%        when an application is started.
%%      * From this window, other windows may be opened (which can, in turn,
%%        open other windows.
%%      * All these windows are non-modal (i.e. the user decides which window
%%        to deal with at any time). The Event Loop, as its name suggests,
%%        contains a loop that uses the Framework to get the next action to
%%        be performed and to dispatch that action to the appropriate window.
%%      * Any window may, from time to time, open a modal window.  This is a
%%        matter of design.
%%
%%
%%----------------------- User Comments --------------------------------
%%----------------------------------------------------------------------
%% TO DO: Add any user comments here.
%% Begin User Code: UserComments
>>
PUSERCODE (VLSTATUS, "GENERATE", "USERCOMMENTS")
<<
%% End User Code: UserComments

%%----------------------- User LocalProcedures -------------------------
%%----------------------------------------------------------------------
%% TO DO: Add any user local procedures here.
%% Begin User Code: LocalProcedures
>>
PUSERCODE (VLSTATUS, "GENERATE", "LOCALPROCEDURES")
<<
%% End User Code: LocalProcedures

%%----------------------- #<PgmEVNameND> ----------------------------
%%----------------------------------------------------------------------
procedure #<PgmEVNameND> ()   \
   local ( vlStatus,          \   % Indicates application status.
           vlMacro,           \
           vlAction,          \   % Action to execute.
           vlPrevEventLoop,   \   % CallBack of the previous event loop
           vlProcessId,       \   % ProcessId of some running process.
           vlWindowName)          % WindowName of some running process.

on error
   %% Purge any messages that were already queued for this window
   let vlProcessId = 0 % not registered yet !
   pMessageQueue(vlStatus, 'PURGE', vlProcessId, '#<WindowNameND>')
   let vlStatus = 'ERROR'
   RETURN
endon

   if $iswinopen('#<WindowNameND>') = $true
      RETURN
   endif

   if $GetProperty('Session', 'Maximum Parameters') < 20
      let vlStatus = $MessageBox( \
             $concat('The Application Framework requires that the', \
                     '\0d"Maximum parameters" setting be at least 20.'), \
             1, 1, 1, '#<PgmEVNameND>')
      set exception error
   endif

   if $GetProperty('Session', 'Parameter Size') < 256
      let vlStatus = $MessageBox( \
             $concat('The Application Framework requires that the', \
                     '\0d"Parameter Size" setting be at least 256.'), \
             1, 1, 1, '#<PgmEVNameND>')
      set exception error
   endif

   %% Some Application Framework routines require access to $DeployServices
   _ZIMServices.OpenDeployServices

   %% If no event loop is running, initialize the Application Framework
   if not $DeployServices.vEventLoopState.CallBack > ''
      $DeployServices.pProcessManager(vlStatus, 'INIT', '', '')
   endif

>>
<<

   %% Launch the main application window.
   #<PgmName> (vlStatus, "ENTERWINDOW")

%% Begin User Code: StartUp
>>
PUSERCODE (VLSTATUS, "GENERATE", "STARTUP")
IF VLSTATUS <> "DEFAULT"
<<
%% End User Code: StartUp
<< %% This commented code is the default for the preceeding modified segment.
>>
ENDIF
<<
%% DEFAULT CODE SEGMENT - Delete this line if you modify the default user code.

   %% Initialize System Settings manager
   %% Uncomment the following line if you wish to enable system settings
%   $DeployServices.pSystemSettings('Initialize', '', '')
>>
IF VLSTATUS = "DEFAULT"
<<
%% End User Code: StartUp
>>
ELSE
   OUTPUT '>> %% End of default user code.'
ENDIF
<<

   let vlPrevEventLoop = $DeployServices.vEventLoopState.CallBack \ % save it
       $DeployServices.vEventLoopState.CallBack = '#<PgmEVNameND>'

%% Main event loop.

   while $iswinopen ("#<WindowNameND>") = $true

      %% Get a user interface event and translate into an application action.
      $DeployServices.pGetAction (vlStatus, $null, vlAction, vlWindowName)

      %% Dispatch actions to the appropriate window.
      $DeployServices.pDispatchAction (vlStatus, vlAction, "", 0, vlWindowName)

   endwhile

%% Begin User Code: CleanUp
>>
PUSERCODE (VLSTATUS, "GENERATE", "CLEANUP")
IF VLSTATUS <> "DEFAULT"
<<
%% End User Code: CleanUp
<< %% This commented code is the default for the preceeding modified segment.
>>
ENDIF

IF VLSTATUS = "DEFAULT"
<<
%% End User Code: CleanUp
>>
ELSE
   OUTPUT '>> %% End of default user code.'
ENDIF
<<

   if vlPrevEventLoop > '' % There is another event loop running
      let $DeployServices.vEventLoopState.CallBack = vlPrevEventLoop
   else % We're the last event loop, turn out the lights
      let $DeployServices.vEventLoopState.CallBack = $null \
          vlProcessId = 0
      $DeployServices.pMessageQueue(vlStatus, 'FINI', vlProcessId, '')
      $DeployServices.pProcessManager(vlStatus, 'FINI', 0, '')
   endif

endprocedure
>>

%% Now generate application window program

%% Get user modifications
PUSERCODE (VLSTATUS, "INIT", "")
PUSERCODE (VLSTATUS, "LOAD", "#<PgmName>")
PUSERCODE (VLSTATUS, "ANALYZE", "")

SET OUTPUT #<PgmName>
<<
%%  Meta object name                #<MetaName>
%%  Generation date                 #<GenerationDate>
%%  Generation time                 #<GenerationTime>
%%  Development Centre Version      #<DCVersion>
%%  Development Centre Revision     #<DCRevision>
>>
SET SAVE
SET HEADINGS OFF
SET COLUMNSPACING 2
LIST ALL OBJMGMTDRIVERENT WHERE METATYPE = "APP" AND METANAME = "#<MetaName>" \
   SORTED BY ATTRDESC \
   FORMAT "%%" $TOCHAR(ATTRDESC,30) ATTRVALUE
SET RESTORE

<<
%%---------------------------------------------------------------------------
%%
%% Generated by the Application Designer from template APPTemplate.
%% APPCode sets up some global macros before generating from APPTemplate.
%% The required objects are built using APPObjects.
%%
%% The attributes of this meta object are listed above.
%%
%%
%% You may wish to customize the generated code. Places where you are likely
%% to do this are marked by comments that begin with '%% TO DO:'
%%
%%---------------------------------------------------------------------------

%%----------------- #<PgmNameND> ------------------------------------------
%%
%% Purpose:  Process Main Application Window.
%%
%%----------------------- User Comments --------------------------------
%%----------------------------------------------------------------------
%% TO DO: Add any user comments here.
%% Begin User Code: UserComments
>>
PUSERCODE (VLSTATUS, "GENERATE", "USERCOMMENTS")
<<
%% End User Code: UserComments


%%----------------------- User LocalProcedures -------------------------
%%----------------------------------------------------------------------
%% TO DO: Add any user local procedures here.
%% Begin User Code: LocalProcedures
>>
PUSERCODE (VLSTATUS, "GENERATE", "LOCALPROCEDURES")
<<
%% End User Code: LocalProcedures

%%---------------------- plOpen ----------------------------------------
%%----------------------------------------------------------------------
localprocedure plOpen (inout vlStatus)

on error
   let vlStatus = "ERROR"
   return
endon

%% Open the Application window.
   window open #<WindowName> at center
%% TO DO: Add any user accelerator keys here.
%% Begin User Code: AcceleratorKeys
>>
PUSERCODE (VLSTATUS, "GENERATE", "ACCELERATORKEYS")
IF VLSTATUS <> "DEFAULT"
<<
%% End User Code: AcceleratorKeys
<< %% This commented code is the default for the preceeding modified segment.
>>
ENDIF
<<
%% DEFAULT CODE SEGMENT - Delete this line if you modify the default user code.
   window set accelerator CtrlF4 \  % Exit
                          AltF4 \   % Exit Application
                          ShiftF4 \ % Command Line
                          F1 \      % Help
                          ShiftF1
>>
IF VLSTATUS = "DEFAULT"
<<
%% End User Code: AcceleratorKeys
>>
ELSE
   OUTPUT '>> %% End of default user code.'
ENDIF
<<
   menu open #<MenuName>
>>
COMPUTE 1 FORMFIELDS \
   WHERE FORMNAME = '#<MenuNameND>' and FIELDNAME = 'miPrinterSetup' \
   EVALUATE ('')
IF $MEMBERCOUNT > 0
<<
   if $zimos <> osWin3
      menu set (unavailable) #<MenuName>.miPrinterSetup
   endif
>>
ENDIF
<<
   menu display
   form open #<FormName>
   form display
%% Begin User Code: OpenWindow
>>
PUSERCODE (VLSTATUS, "GENERATE", "OPENWINDOW")
<<
%% End User Code: OpenWindow
   window activate #<WindowName>

   let vlStatus = "OK"
endprocedure

%%---------------------- plClose ---------------------------------------
%%----------------------------------------------------------------------
localprocedure plClose (inout vlStatus)

   if $iswinopen ("#<WindowNameND>") = $true
      window close #<WindowName>
   endif
%% Begin User Code: CloseWindow
>>
PUSERCODE (VLSTATUS, "GENERATE", "CLOSEWINDOW")
<<
%% End User Code: CloseWindow
endprocedure

%%---------------------- plExecAction ----------------------------------
%%----------------------------------------------------------------------
localprocedure plExecAction ( inout vlStatus, \
                              in    vlAction  \
                            ) \
                      local (vlNumRecords, \
                             vlProcessId, \
                             vlDocName, \
                             vlResponse)

   if _$FrameworkTrace = $true
      $DeployServices.pFrameworkTrace(vlStatus, 'LOGTEXT', \
         $concat('#<PgmNameND>: Action=', vlAction))
   endif

   let vlStatus = "OK"

   case

%% TO DO: Add any user action execution code here.
%%        Always begin each action code block with "when vlAction ..."
%% Begin User Code: ExecActions
>>
PUSERCODE (VLSTATUS, "GENERATE", "EXECACTIONS")
<<
%% End User Code: ExecActions

   when vlAction in ("ENTERWINDOW", "EXPOSEWINDOW")
      if vlAction = "EXPOSEWINDOW" % Bring the window to the front
         window display #<WindowName>
      endif
      $DeployServices.pSetCurrentProcess('#<WindowNameND>')
      %% deactivate tool bar and, if in design mode, remember
      %% this is the most recent design window
      $DeployServices.pToolBarManager(vlStatus, 'SUSPEND', '') % No Toolbar
      if #<StateName>.stDesignMode = $true
         let vAppDesign.stLastWindow = "#<WindowNameND>"
      endif

   when vlAction = "REOPEN"
      %% Do nothing.

   when vlAction = "EXITWINDOW"
      %% Do nothing.

%% TO DO: The next few actions are associated with menu items. If
%%        you modify the menu you may need to either delete specific
%%        cases, or add new ones. Note how the state structure
%%        is modified to show various debugging options. This is
%%        checked in the main event loop program.
%% Begin User Code: MenuItems
>>
PUSERCODE (VLSTATUS, "GENERATE", "MENUITEMS")
<<
%% End User Code: MenuItems

   when vlAction = "HELP"
%% Begin User Code: ExecHelp
>>
PUSERCODE (VLSTATUS, "GENERATE", "EXECHELP")
IF VLSTATUS <> "DEFAULT"
<<
%% End User Code: ExecHelp
<< %% This commented code is the default for the preceeding modified segment.
>>
ENDIF
<<
%% DEFAULT CODE SEGMENT - Delete this line if you modify the default user code.
      help ThisWindow.WindowTag
>>
IF VLSTATUS = "DEFAULT"
<<
%% End User Code: ExecHelp
>>
ELSE
   OUTPUT '>> %% End of default user code.'
ENDIF
<<

   when vlAction = "HELPITEM"
%% Begin User Code: ExecHelpItem
>>
PUSERCODE (VLSTATUS, "GENERATE", "EXECHELPITEM")
IF VLSTATUS <> "DEFAULT"
<<
%% End User Code: ExecHelpItem
<< %% This commented code is the default for the preceeding modified segment.
>>
ENDIF
<<
%% DEFAULT CODE SEGMENT - Delete this line if you modify the default user code.
      help ThisForm.FieldTag
>>
IF VLSTATUS = "DEFAULT"
<<
%% End User Code: ExecHelpItem
>>
ELSE
   OUTPUT '>> %% End of default user code.'
ENDIF
<<

   when vlAction = "HELPCONTENTS"
%% Begin User Code: ExecHelpContents
>>
PUSERCODE (VLSTATUS, "GENERATE", "EXECHELPCONTENTS")
IF VLSTATUS <> "DEFAULT"
<<
%% End User Code: ExecHelpContents
<< %% This commented code is the default for the preceeding modified segment.
>>
ENDIF
<<
%% DEFAULT CODE SEGMENT - Delete this line if you modify the default user code.
      help
>>
IF VLSTATUS = "DEFAULT"
<<
%% End User Code: ExecHelpContents
>>
ELSE
   OUTPUT '>> %% End of default user code.'
ENDIF
<<

   when vlAction = "HELPSEARCH"
%% Begin User Code: ExecHelpSearch
>>
PUSERCODE (VLSTATUS, "GENERATE", "EXECHELPSEARCH")
<<
%% End User Code: ExecHelpSearch

%% TO DO: Add any user help action execution code here.
%%        - Begin each action code block with "when vlAction ..."
%%        - You must also add a corresponding call to plHelpAction from
%%          the "ExecActions" user code segment in the plExecAction routine.
%% Begin User Code: HelpActions
>>
PUSERCODE (VLSTATUS, "GENERATE", "HELPACTIONS")
<<
%% End User Code: HelpActions

   when vlAction in ("EXIT", "EXITAPPLICATION", "DESIGNEXIT")
      $DeployServices.pDispatchAction(vlStatus, \
         'EXIT', '#TOCHILDREN', #<StateName>.stProcessId, '')
      if vlStatus <> 'CANCEL' % Exit has not been cancelled by a child
         plClose(vlStatus)
         $DeployServices.pUnRegisterProcess(vlStatus, \
            #<StateName>.stProcessId, '')
         %% Exit the Application Designer unless EXIT came from there
         if #<StateName>.stDesignMode = $true and vlAction <> "DESIGNEXIT"
            $DeployServices.pPostActionQueue ("EXIT", "wAppDesign")
         endif
      endif

   when vlAction in ("ABORT", "ABORTAPPLICATION")
      $DeployServices.pDispatchAction(vlStatus, \
         'ABORT', '#TOCHILDREN', #<StateName>.stProcessId, '')
      plClose(vlStatus)
      $DeployServices.pUnRegisterProcess(vlStatus, \
         #<StateName>.stProcessId, '')
      %% Exit the Application Designer
      if #<StateName>.stDesignMode = $true
         $DeployServices.pPostActionQueue ("ABORT", "wAppDesign")
      endif

%% action to say we are in design mode
   when vlAction = "DESIGNMODE"
      let #<StateName>.stDesignMode = $true \
          vAppDesign.stLastWindow = "#<WindowNameND>"
      window set add accelerator CtrlF5 CtrlF6 CtrlF7 CtrlF8 CtrlF9
      menu set (not suppress) #<MenuName>.mDesign

%% special action to handle design time events
   when vlAction like "META%"
      %% Queue an edit action for the app design window
      let vAppDesign.stMetaEditName = "#<MetaName>" \
          vAppDesign.stMetaEditPId = #<StateName>.stProcessId
      pPostActionQueue($concat($trim(vlAction), ':APP'), 'wAppDesign')

   when vlAction = "CLOSEREGEN"
%% Close prior to re-generation
      plClose (vlStatus)

>>
FIND FFS WHERE FORMNAME = "#<MenuNameND>" AND DirName = "#<DirName>" AND \
   WDGTAG LIKE "MT\\%%"
WHILE $SETCOUNT > 0
   LET <MMETANAME> = $SUBSTRING(WDGTAG, 4, 18) \
       <MWDGTAG> = $TOUPPER($TRIM(WDGTAG))
   COMPUTE 1 METAOBJATTRS \
      WHERE METANAME = '#<MMETANAME>' AND ATTRNAME = "PGMNAME" \
      EVALUATE (LET VLPGMNAME = ATTRVALUE)
   LET <MPGMNAME> = $TOUPPER($TRIM(VLPGMNAME))
<<
   when vlAction = "#<MWDGTAG>"

      #<MPGMNAME> (vlStatus, \
         {"DESIGNMODE" where #<StateName>.stDesignMode = $true, \
          "ENTERWINDOW"})

>>
   LET $SETCOUNT = $SETCOUNT - 1
   NEXT
ENDWHILE

FIND FFS WHERE FORMNAME = "#<MenuNameND>" AND DirName = "#<DirName>" AND \
   WDGTAG LIKE "_CMD%"
WHILE $SETCOUNT > 0
   LET <MWDGTAG> = $TOUPPER($TRIM(WDGTAG)) \
       <CMDLINE> = $TRIM(ERRORMSG)
<<
   when vlAction = "#<MWDGTAG>"
      #<CMDLINE>

>>
   LET $SETCOUNT = $SETCOUNT - 1
   NEXT
ENDWHILE
<<

   otherwise
      $DeployServices.pUserMessage ('UNKNOWNACTION', errUNKNOWNACTION, \
         '', '', 0, vlAction, vlResponse)
   endcase

ExitProc:
endprocedure

%%---------------------- plInitialize ----------------------------------
%%----------------------------------------------------------------------
localprocedure plInitialize ( inout vlStatus, inout vlAction )

on error
   if #<StateName>.stProcessId is not $null % Already registered
      plClose (vlStatus)
      $DeployServices.pUnRegisterProcess(vlStatus, \
         #<StateName>.stProcessId, '')
   elseif $iswinopen("#<WindowNameND>") = $true % Only window is open
      plClose (vlStatus)
   endif
   let vlStatus = "ERROR"
   return
endon

>>
<<

   let vlStatus = ""

%% Initialize the user interface and database objects.
   plOpen (vlStatus)
   if vlStatus = "ERROR"
      set exception error
   endif

%% Initialize the process state.
   let #<StateName>.stWindowName = "#<WindowNameND>" \
       #<StateName>.stWindowTag = ThisWindow.WindowTag

   if vlAction = 'REOPEN'
      let vlAction = 'DESIGNMODE'
   else
      %% Register the process.
      $DeployServices.pRegisterProcess (vlStatus, \
         "#<MetaName>", "#<WindowNameND>", "", \
         "Control Window", "#<PgmNameND>", \
         $DeployServices.cApplicationClass, $null, \
         #<StateName>.stProcessId)
      if vlStatus = "ERROR"
         set exception error
      endif
      %% Initially assume we are NOT in design mode
      let #<StateName>.stDesignMode = $false
   endif

endprocedure

%%---------------------- #<PgmNameND> ------------------------------
%%----------------------------------------------------------------------
procedure #<PgmNameND> \
      ( inout vlStatus, \
        in    vlAction \
      )

on error
   let vlStatus = "ERROR"
   return
endon

   %% Establish a running state.
   let vlStatus = ""
   if $iswinopen("#<WindowNameND>") = $false \
         or #<StateName>.stProcessId = $null \
         or vlAction = "REOPEN"
      plInitialize (vlStatus, vlAction)
      if vlStatus = "ERROR"
         set exception error
      endif
      if vlAction <> 'ENTERWINDOW' % Begin with 'ENTERWINDOW'
         $DeployServices.pPostActionQueue(vlAction, \
            #<StateName>.stWindowName)
         let vlAction = 'ENTERWINDOW'
      endif
   endif
   window set current #<WindowName>

%% Execute the Action.
   plExecAction (vlStatus, vlAction)

endprocedure

>>

SET RESTORE

ENDPROCEDURE
%%---------------------------------------------------------------

GENERATE PLCODETEMPLATE ()
